#include <stdlib.h>
#include <conio.h>
#include <dos.h>

#define LENX 40
#define LENY 23

#define QUANT 15

#define PRISE 100

#define FACE 'o'
#define GOAL '*'
#define SPACE ' '
#define HWALL ''
#define VWALL ''
#define SLASH1 '\\'
#define SLASH2 '/'

#define F1 59
#define F2 60
#define F9 67
#define F0 68

int wall[] = { 2,3,0,1 };
int slash1[] = { 3,2,1,0 };
int slash2[] = { 1,0,3,2 };

char field [ LENX ] [ LENY ];
int x,y,dir,level,count,score;
char * ptr;

void main ( void );
void init ( void );
void clear_field ( void );
void make_wall ( void );
void make_corn ( void );
void get_level ( void );
void game ( void );
void pr_cell ( void );
void pr_goal ( void );
void make_goal ( void );
void pause ( void );
void pr_keyb ( void );
void quit ( void );
void shift( void );
void put ( char );
void msg1 ( char * );
void msg2 ( char * );
void cursor ( char,char );

void main()
{
	init();
	game();
}

void init()
{
	textmode( 1 );
	gotoxy( 2,1 );
	cputs( "SCORE    0    PING-PONG    by C.Slobin" );
	gotoxy( 2,LENY+2 );
	cputs( "F1 - pause  F2 - quit  F9 - \\  F10 - /" );
	clear_field();
	make_wall();
	make_corn();
	get_level();
	make_goal();
	cursor( 020,0 );
	x = 2; y = LENY/2; dir = 1; score = 0;
}

void clear_field()
{
	for( x = 0; x < LENX; x++ )
		for( y = 0; y < LENY; y++ )
			field[x][y] = SPACE;
}

void make_wall()
{
	for( x = 1; x < LENX-1; x++ )
	{
		put( field[x][y=0] = HWALL );
		put( field[x][y=LENY-1] = HWALL );
	}
	for( y = 1; y < LENY-1; y++ )
	{
		put( field[x=0][y] = VWALL );
		put( field[x=LENX-1][y] = VWALL );
	}
}

void make_corn()
{
	gotoxy( 1,2 ); putch( '' );
	gotoxy( LENX,2 ); putch( '' );
	gotoxy( 1,LENY+1 ); putch( '' );
	gotoxy( LENX,LENY+1 ); putch( '' );
}

void get_level()
{
	unsigned seed;
	msg2( "level (1-9)");
	do
	{
		for( seed = 0; ! kbhit(); seed++ );
		level = getch() - '0';
	} while( level < 1 || level > 9 );
	msg2( "by C.Slobin" );
	srand( seed );
}

void game()
{
	for(;;)
	{
		put( FACE );
		ptr = &field[x][y];
		pr_cell();
		delay( level * QUANT );
		pr_keyb();
		put( *ptr );
		shift();
	}
}

void pr_cell()
{
	switch( *ptr )
	{
		case GOAL: pr_goal(); break;
		case SPACE: break;
		case HWALL:
		case VWALL: dir = wall[dir]; break;
		case SLASH1: dir = slash1[dir]; *ptr = SLASH2; break;
		case SLASH2: dir = slash2[dir]; *ptr = SLASH1; break;
	}
}

void pr_goal()
{
	*ptr = SPACE;
	score += count;
	gotoxy( 2,1 );
	cprintf( "SCORE%5d",score );
	make_goal();
}

void make_goal()
{
	int xx,yy;
	do
	{
		xx = random( LENX-2 ) + 1;
		yy = random( LENY-2 ) + 1;
	} while( field[xx][yy] != SPACE );
	field[xx][yy] = GOAL;
	gotoxy( xx+1,yy+2 );
	putch( GOAL );
	count = PRISE;
}

void pr_keyb()
{
	if( kbhit() && getch() == 0 )
		switch( getch() )
		{
			case F1: pause(); break;
			case F2: quit(); break;
			case F9: if( *ptr == SPACE ) { *ptr = SLASH1; dir = slash1[dir]; } break;
			case F0: if( *ptr == SPACE ) { *ptr = SLASH2; dir = slash2[dir]; } break;
		}
}

void pause()
{
	cursor( 6,7 );
	msg2( "hit any key" );
	getch() || getch();
	msg2( "by C.Slobin" );
	cursor( 020,0 );
}

void quit()
{
	cursor( 6,7 );
	msg1( "GAME OVER" );
	msg2( "hit any key" );
	getch();
	textmode( 3 );
	exit( 0 );
}

void shift()
{
	if( count > 1 ) count--;
	switch( dir )
	{
		case 0: y--; break;
		case 1: x++; break;
		case 2: y++; break;
		case 3: x--; break;
	}
}

void put( c )
	char c;
{
	gotoxy( x+1,y+2 );
	putch( c );
}

void msg1( s )
	char * s;
{
	gotoxy( 16,1 );
	cprintf( "%.9s",s );
}

void msg2( s )
	char * s;
{
	gotoxy( 29,1 );
	cprintf( "%.11s",s );
}

void cursor( h,l )
	char h,l;
{
	struct BYTEREGS r;
	r.ah = 1;
	r.ch = h;
	r.cl = l;
	int86( 0x10,&r,&r );
}

/* eof */
